https://leetcode.com/articles/minimum-swaps-to-make-sequences-increasing/
https://blog.xiadong.info/2018/03/18/LeetCode-801-Minimum-Swaps-To-Make-Sequences-Increasing/
2. DFS, Brute Force
http://zxi.mytechroad.com/blog/dynamic-programming/leetcode-801-minimum-swaps-to-make-sequences-increasing/
We have two integer sequences
A
and B
of the same non-zero length.
We are allowed to swap elements
A[i]
and B[i]
. Note that both elements are in the same index position in their respective sequences.
At the end of some number of swaps,
A
and B
are both strictly increasing. (A sequence is strictly increasing if and only if A[0] < A[1] < A[2] < ... < A[A.length - 1]
.)
Given A and B, return the minimum number of swaps to make both sequences strictly increasing. It is guaranteed that the given input always makes it possible.
Example: Input: A = [1,3,5,4], B = [1,2,3,7] Output: 1 Explanation: Swap A[3] and B[3]. Then the sequences are: A = [1, 3, 5, 7] and B = [1, 2, 3, 4] which are both strictly increasing.
Note:
A, B
are arrays with the same length, and that length will be in the range[1, 1000]
.A[i], B[i]
are integer values in the range[0, 2000]
.
The cost of making both sequences increasing up to the first
i
columns can be expressed in terms of the cost of making both sequences increasing up to the first i-1
columns. This is because the only thing that matters to the i
th column is whether the previous column was swapped or not. This makes dynamic programming an ideal choice.
Let's remember
n1
(natural1
), the cost of making the first i-1
columns increasing and not swapping the i-1
th column; and s1
(swapped1
), the cost of making the first i-1
columns increasing and swapping the i-1
th column.
Now we want candidates
n2
(and s2
), the costs of making the first i
columns increasing if we do not swap (or swap, respectively) the i
th column.
Algorithm
For convenience, say
a1 = A[i-1], b1 = B[i-1]
and a2 = A[i], b2 = B[i]
.
Now, if
a1 < a2
and b1 < b2
, then it is allowed to have both of these columns natural (unswapped), or both of these columns swapped. This possibility leads to n2 = min(n2, n1)
and s2 = min(s2, s1 + 1)
.
Another, (not exclusive) possibility is that
a1 < b2
and b1 < a2
. This means that it is allowed to have exactly one of these columns swapped. This possibility leads to n2 = min(n2, s1)
or s2 = min(s2, n1 + 1)
.
Note that it is important to use two if statements separately, because both of the above possibilities might be possible.
At the end, the optimal solution must leave the last column either natural or swapped, so we take the minimum number of swaps between the two possibilities.
public int minSwap(int[] A, int[] B) {
// n: natural, s: swapped
int n1 = 0, s1 = 1;
for (int i = 1; i < A.length; ++i) {
int n2 = Integer.MAX_VALUE, s2 = Integer.MAX_VALUE;
if (A[i-1] < A[i] && B[i-1] < B[i]) {
n2 = Math.min(n2, n1);
s2 = Math.min(s2, s1 + 1);
}
if (A[i-1] < B[i] && B[i-1] < A[i]) {
n2 = Math.min(n2, s1);
s2 = Math.min(s2, n1 + 1);
}
n1 = n2;
s1 = s2;
}
return Math.min(n1, s1);
}
int minSwap(vector<int>& A, vector<int>& B) {
const int n = A.size();
vector<int> keep(n, INT_MAX);
vector<int> swap(n, INT_MAX);
keep[0] = 0;
swap[0] = 1;
for (int i = 1; i < n; ++i) {
if (A[i] > A[i - 1] && B[i] > B[i - 1]) {
// Good case, no swapping needed.
keep[i] = keep[i - 1];
// Swapped A[i - 1] / B[i - 1], swap A[i], B[i] as well
swap[i] = swap[i - 1] + 1;
}
if (B[i] > A[i - 1] && A[i] > B[i - 1]) {
// A[i - 1] / B[i - 1] weren't swapped.
swap[i] = min(swap[i], keep[i - 1] + 1);
// Swapped A[i - 1] / B[i - 1], no swap needed for A[i] / B[i]
keep[i] = min(keep[i], swap[i - 1]);
}
}
return min(keep.back(), swap.back());
}
https://blog.xiadong.info/2018/03/18/LeetCode-801-Minimum-Swaps-To-Make-Sequences-Increasing/
使用DP,如果array长度为n,那么使用2行n列的二维DP。
dp[0][i]
保存i
位置没有交换的步数,dp[1][i]
保存i
位置交换了的最小步数。与i-1
位置的情况组合之后有四种情况。但是实际上只有两种:- 在
i-1
位置没有交换的情况下i
位置不需要交换;i-1
和i
位置都进行了交换。这两种情况都是A
和B
的i
元素分别大于i-1
元素。 - 如果
A
或B
中有一个不满足递增,那么就要交换,分为i-1
交换和i
交换两种。
int minSwap(vector<int>& A, vector<int>& B) { int len = A.size(); vector<vector<int>> dp(2, vector<int>(len, INT_MAX)); dp[0][0] = 0; dp[1][0] = 1; for (int i = 1; i < len; i++) { if (A[i] > A[i - 1] && B[i] > B[i - 1]) { dp[0][i] = min(dp[0][i], dp[0][i - 1]); dp[1][i] = min(dp[1][i], dp[1][i - 1]) + 1; } if (A[i] > B[i - 1] && B[i] > A[i - 1]) { dp[0][i] = min(dp[0][i], dp[1][i - 1]); dp[1][i] = min(dp[1][i], dp[0][i - 1]) + 1; } } return min(dp[0][len - 1], dp[1][len - 1]); }https://blog.csdn.net/zjucor/article/details/79599287
- def minSwap(self, A, B):
- """
- :type A: List[int]
- :type B: List[int]
- :rtype: int
- """
- dp = [[999999,999999] for _ in range(len(A))]
- dp[0][0]=0
- dp[0][1]=1
- for i in range(1, len(A)):
- if dp[i-1][0]!=999999 and A[i]>A[i-1] and B[i]>B[i-1]:
- dp[i][0] = min(dp[i-1][0], dp[i][0])
- if dp[i-1][1]!=999999 and A[i]>B[i-1] and B[i]>A[i-1]:
- dp[i][0] = min(dp[i-1][1], dp[i][0])
- if dp[i-1][0]!=999999 and A[i]>B[i-1] and B[i]>A[i-1]:
- dp[i][1] = min(dp[i-1][0]+1, dp[i][1])
- if dp[i-1][1]!=999999 and A[i]>A[i-1] and B[i]>B[i-1]:
- dp[i][1] = min(dp[i-1][1]+1, dp[i][1])
- return min(dp[-1])
分三种情况讨论:
def minSwap(self, A, B):
"""
:type A: List[int]
:type B: List[int]
:rtype: int
"""
swap, keep = 1, 0
for i in range(1, len(A)):
if A[i] <= A[i - 1] or B[i] <= B[i - 1]:
# swap
nswap = keep + 1
nkeep = swap
elif A[i] > B[i - 1] and B[i] > A[i - 1]:
# swap or keep
nkeep = min(keep, swap)
nswap = nkeep + 1
else:
# keep
nkeep = keep
nswap = swap + 1
swap, keep = nswap, nkeep
return min(swap, keep)2. DFS, Brute Force
http://zxi.mytechroad.com/blog/dynamic-programming/leetcode-801-minimum-swaps-to-make-sequences-increasing/
int minSwap(vector<int>& A, vector<int>& B) {
int ans = INT_MAX;
dfs(A, B, 0, 0, ans);
return ans;
}
private:
void dfs(vector<int>& A, vector<int>& B, int i, int c, int& ans) {
if (c >= ans) return;
if (i == A.size()) {
ans = min(ans, c);
return;
}
if (i == 0 || A[i] > A[i - 1] && B[i] > B[i - 1])
dfs(A, B, i + 1, c, ans);
if (i == 0 || A[i] > B[i - 1] && B[i] > A[i - 1]) {
swap(A[i], B[i]);
dfs(A, B, i + 1, c + 1, ans);
swap(A[i], B[i]);
}
}